﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            ObservableCollection<GrandChild> gc = new ObservableCollection<GrandChild>();
            gc.Add(new GrandChild() { GrandChildName = "gc" });
            gc.Add(new GrandChild() { GrandChildName = "gc" });

            ObservableCollection<GrandChild> gc1 = new ObservableCollection<GrandChild>();
            gc1.Add(new GrandChild() { GrandChildName = "gc1" });
            gc1.Add(new GrandChild() { GrandChildName = "gc1" });

            ObservableCollection<Child> c = new ObservableCollection<Child>();
            c.Add(new Child() { ChildName = "c", GrandChildren = gc });

            ObservableCollection<Child> c1 = new ObservableCollection<Child>();
            c1.Add(new Child() { ChildName = "c1", GrandChildren = gc1 });

            ObservableCollection<Parent> p = new ObservableCollection<Parent>();
            p.Add(new Parent(){ Name = "p", Children = c});
            p.Add(new Parent() { Name = "p1", Children = c1 });

            this.DataContext = p;
        }
    }

    public class Parent : INotifyPropertyChanged
    {
        private string name;

        public string Name
        {
            get { return name; }
            set 
            { 
                name = value; 
                PropChanged("Name");
            }
        }

        private ObservableCollection<Child> children;

        public ObservableCollection<Child> Children
        {
            get { return children; }
            set { children = value; PropChanged("Children"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
        
    }

    public class Child : INotifyPropertyChanged
    {
        private string childName;

        public string ChildName
        {
            get { return childName; }
            set { childName = value; PropChanged("ChildName"); }
        }

        private ObservableCollection<GrandChild> grandChildren;

        public ObservableCollection<GrandChild> GrandChildren
        {
            get { return grandChildren; }
            set { grandChildren = value; PropChanged("GrandChildren"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
        
    }

    public class GrandChild : INotifyPropertyChanged
    {
        private string grandChildname;

        public string GrandChildName
        {
            get { return grandChildname; }
            set { grandChildname = value; PropChanged("GrandChildName"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
        
    }
}
